=== debian/changelog ===
connectome-workbench (1.4.1-4) unstable; urgency=medium

  * debian/rules
    - fixed  grep invocation to match architecture to use -E not -e to have
      "(...|...)"

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 15 Nov 2019 11:29:31 -0500

connectome-workbench (1.4.1-3) unstable; urgency=medium

  * debian/patches/series
    - fixed the listing of two patches being in the same line

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 14 Nov 2019 09:58:37 -0500

connectome-workbench (1.4.1-2) unstable; urgency=medium

  * debian/control
    - "optional" instead of "extra" priority
    - policy compliance boosted to 4.4.0 (should be all kosher)
  * debian/{rules,patches/000*}
    - disable building memory demanding help on mipsel, m68k, sh4
      architectures

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 13 Nov 2019 23:17:53 -0500

connectome-workbench (1.4.1-1) unstable; urgency=medium

  * New upstream release
  * Updated debian/copyright from upstream
  * debian/control
    - added libglm-dev to build-depends (upstream bundles a copy but
      should pick up system library if available)
    - added opencl-c-headers to build-depends

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 05 Nov 2019 20:32:34 -0500
